
// Include Libraries
#include "Arduino.h"
#include "DHT.h"
#include "SD.h"


// Pin Definitions
#define DHT_PIN_DATA	2
#define SDFILE_PIN_CS	10



// Zmienne globalne i definicje


// inicjalizacja obiektu
DHT dht(DHT_PIN_DATA);
File sdFile;


// zdefiniuj zmienne do menu testowania
const int timeout = 10000;       //define timeout of 10 sec
char menuOption = 0;
long time0;

// Skonfiguruj niezbędne elementy do działania obwodu. Działa pierwszy za każdym razem, gdy obwód jest zasilany energią elektryczną.
void setup() 
{
    // Skonfiguruj Serial, który jest przydatny do debugowania
    // Użyj Serial Monitor, aby wyświetlić drukowane wiadomości
    Serial.begin(9600);
    while (!Serial) ; // poczekaj na połączenie z portem szeregowym. Potrzebny do natywnego USB
    Serial.println("start");
    
    dht.begin();
    // Ustaw pin SPI SS na wyjście, w przeciwnym razie funkcje biblioteki SD nie będą działać.
    // SD jest domyślnie ustawiony na używanie SPI SS Arduino pin 10 jako wybór chipa (CS).
    // Aby zmienić pin użyj SD.begin (SD_CS_PIN)
    pinMode(SDFILE_PIN_CS, OUTPUT);
    // Aby zmienić pin używać SD.begin (SD_CS_PIN)

    if (!SD.begin()) {
    Serial.println(F("Karta nieudana lub nieobecna"));
    while(1);
    }
    Serial.println(F("karta zainicjowana."));
    menuOption = menu();
    
}

// Główna logika twojego obwodu. Definiuje interakcję między wybranymi komponentami. Po instalacji działa w kółko, w wiecznej pętli.
void loop() 
{
    
    
    if(menuOption == '1') {
    // DHT22/11 Humidity and Temperature Sensor - Test Code
    // Odczyt wilgotności w%
    float dhtHumidity = dht.readHumidity();
    // Odczyt temperatury w stopniach Celsjusza, do użytku w stopniach Fahrenheita .readTempF ()
    float dhtTempC = dht.readTempC();
    Serial.print(F("Humidity: ")); Serial.print(dhtHumidity); Serial.print(F(" [%]\t"));
    Serial.print(F("Temp: ")); Serial.print(dhtTempC); Serial.println(F(" [C]"));

    }
    else if(menuOption == '2') {
    // Micro SD module - Test Code
    // Przykładowy kod SD tworzy plik datalog.txt do rejestrowania danych czujnika
    // otwórz plik. pamiętaj, że jednocześnie może być otwarty tylko jeden plik,
    // więc musisz zamknąć to przed otwarciem kolejnego.
    
    sdFile = SD.open("datalog.txt", FILE_WRITE);
    // jeśli plik istnieje na karcie SD, zapisz dane czujnika
    if (sdFile) {
    //zapis do pliku
    sdFile.println("ENTER SENSOR DATA HERE");
    // zamkniecie tego pliku
    sdFile.close();
    // Odkomentowanie drukowania do portu szeregowego
    //Serial.println("ENTER SENSOR DATA HERE");
    } 
    else {
    // if the file didn't open, print an error
    Serial.println(F("błąd podczas otwierania pliku."));
    }
    }
    
    if (millis() - time0 > timeout)
    {
        menuOption = menu();
    }
    
}

// Funkcja menu do wyboru komponentów do testowania

// Postępuj zgodnie z instrukcjami monitora szeregowego

char menu()
{

    Serial.println(F("\nKtóry składnik chcesz przetestować?"));
    Serial.println(F("(1) DHT22/11 Humidity and Temperature Sensor"));
    Serial.println(F("(2) Micro SD module"));
    Serial.println(F("(menu) wyślij cokolwiek innego lub naciśnij przycisk resetowania na pokładzie\n"));
    while (!Serial.available());

    // Read data from serial monitor if received
    while (Serial.available()) 
    {
        char c = Serial.read();
        if (isAlphaNumeric(c)) 
        {   
            
            if(c == '1') 
    			Serial.println(F("Teraz testuję czujnik wilgotności i temperatury DHT22 / 11"));
    		else if(c == '2') 
    			Serial.println(F("Testuję teraz moduł Micro SD"));
            else
            {
                Serial.println(F("nielegalne wprowadzanie!"));
                return 0;
            }
            time0 = millis();
            return c;
        }
    }
}
